/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is FullerScreen.
 *
 * The Initial Developer of the Original Code is
 * Disruptive Innovations SARL
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * Copie d'un element ayant pour ID elementID contenu dans un objet window, vers un canvas existant
 */

function gCanvasCopyObject(nsIWindow, canvas, elementID)
{
  var originalWidth = nsIWindow.contentWindow.innerWidth + nsIWindow.contentWindow.scrollMaxX;
  var originalHeight = nsIWindow.contentWindow.innerHeight + nsIWindow.contentWindow.scrollMaxY;
  var startX = 0;
  var startY = 0;

  if(typeof elementID != 'undefined')
  {
    var myElement = nsIWindow.contentDocument.getElementById(elementID);
    originalWidth = myElement.offsetWidth;
    originalHeight = myElement.offsetHeight;
    var pos = gCanvasPosition(myElement);
    startX = pos[0];
    startY = pos[1];
  }

  // On retaille en prservant la largeur
  gCanvasResize(canvas, (kGCResizePixel & kGCResizeNoRatio), canvas.width, Math.round(originalHeight/originalWidth*canvas.width));

  var ctx = canvas.getContext("2d");
  ctx.clearRect(0, 0, canvas.width, canvas.height);
  ctx.save();
  // Scale le canvas
  gCanvasScale(canvas, kGCScaleInside, originalWidth, originalHeight);
  // Copy effectivement
  gCanvasCopy(canvas, null, nsIWindow.contentWindow, startX, startY, (originalWidth+startX), (originalHeight+startY));
  ctx.restore();

}
