/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is FullerScreen.
 *
 * The Initial Developer of the Original Code is
 * Disruptive Innovations SARL
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *
 * ***** END LICENSE BLOCK ***** */

var gDialog = {};

function Init()
{
  gDialog.FStypes = document.getElementById("FStypes");
  gDialog.FSincompatMIMEtype = document.getElementById("FSincompatMIMEtype");
  gDialog.addButton = document.getElementById("addButton");
  gDialog.removeButton = document.getElementById("removeButton");

  var types = GetPrefs().getCharPref("extensions.fullerscreen.incompatibleMIMETypes");
  var typesArray = types.split(",");
  for (var i = 0; i < typesArray.length; i++)
    gDialog.FStypes.appendItem(typesArray[i], typesArray[i]);

  var toolbars;
  if (window.opener.document.documentElement.id == "extensionsManager")
    toolbars = window.opener.opener.document.getElementById("navigator-toolbox")
                                            .getElementsByTagName("toolbar");
  else
    toolbars = window.opener.document.getElementById("navigator-toolbox")
                                     .getElementsByTagName("toolbar");
  gDialog.VisibleToolbars = document.getElementById("VisibleToolbars");
  for (var i = 0; i < toolbars.length; i++)
  {
    var t = toolbars[i];
    if (t.id != "FindToolbar")
    {
      var name  = t.getAttribute("toolbarname");
      var label = name ? name : t.id;
      var checkbox = document.createElement("checkbox");
      checkbox.setAttribute("label", label);
      checkbox.setAttribute("value", t.id);
      if (t.getAttribute("fullscreentoolbar"))
        checkbox.setAttribute("checked", "true");
      gDialog.VisibleToolbars.appendChild(checkbox);
    }
  }
}

function onListboxSelectionChanged(aList)
{
  var item = aList.selectedItem;
  if (item)
  {
    gDialog.removeButton.removeAttribute("disabled");
    gDialog.FSincompatMIMEtype.value = item.getAttribute("value");
    gDialog.addButton.addAttribute("disabled", "true");
  }
  else
    gDialog.removeButton.addAttribute("disabled", "true");
}

function StorePrefs()
{
  var l = gDialog.FStypes.childNodes.length;
  var pref = "";
  for (var i = 0 ; i < l ; i++)
  {
    pref += gDialog.FStypes.getItemAtIndex(i).value;
    if (i != l - 1)
      pref += ",";
  }
  GetPrefs().setCharPref("extensions.fullerscreen.incompatibleMIMETypes", pref);

  var checkboxes = gDialog.VisibleToolbars.getElementsByTagName("checkbox");
  var topWindow = (window.opener.document.documentElement.id == "extensionsManager") ?
                     window.opener.opener : window.opener;
  for (var i = 0; i < checkboxes.length; i++)
  {
    var c = checkboxes[i];
    var t;
    t = topWindow.document.getElementById(c.getAttribute("value"));
    // sanity check
    if (t)
    {
      if (c.getAttribute("checked"))
      {
        t.setAttribute("fullscreentoolbar", "true");
      }
      else
      {
        t.removeAttribute("fullscreentoolbar");
      }
      if (topWindow.FS_data.mIsFullerScreen)
      {
        if (c.getAttribute("checked"))
          t.removeAttribute("moz-collapsed");
        else
          t.setAttribute("moz-collapsed", "true");
      }

      topWindow.document.persist(t.id, "fullscreentoolbar");
    }
  }
}

function GetPrefs()
{
  if (gDialog.mPrefs)
    return gDialog.mPrefs;

  try {
    gDialog.mPrefs = Components.classes["@mozilla.org/preferences-service;1"]
                               .getService(Components.interfaces.nsIPrefBranch);
  } catch (e) {
    gDialog.mPrefs = null;
  }

  return gDialog.mPrefs;
}

function onTypeChanged(aT)
{
  var v = aT.value;
  var l = gDialog.FStypes.childNodes.length;
  for (var i = 0; i < l; i++)
    if (v == gDialog.FStypes.getItemAtIndex(i).value)
    {
      gDialog.addButton.setAttribute("disabled", "true");
      return;
    }
  gDialog.addButton.removeAttribute("disabled");
}

function RemoveType()
{
  var item = gDialog.FStypes.selectedItem;
  if (item)
  {
    gDialog.FStypes.removeItemAt(gDialog.FStypes.selectedIndex);
    gDialog.addButton.removeAttribute("disabled");
    gDialog.removeButton.setAttribute("disabled", "true");
  }
}

function AddType()
{
  var value = gDialog.FSincompatMIMEtype.value;
  if (value)
  {
    gDialog.FStypes.appendItem(value, value);
    gDialog.addButton.setAttribute("disabled", "true");
  }
}

